/* ###
 * IP: GHIDRA
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package agent.dbgmodel.jna.dbgmodel.concept;

import com.sun.jna.*;
import com.sun.jna.platform.win32.WinDef.BOOLByReference;
import com.sun.jna.platform.win32.WinNT.HRESULT;
import com.sun.jna.ptr.PointerByReference;

import agent.dbgmodel.jna.dbgmodel.UnknownWithUtils;

public class WrapIDynamicKeyProviderConcept extends UnknownWithUtils
		implements IDynamicKeyProviderConcept {
	public static class ByReference extends WrapIDynamicKeyProviderConcept
			implements Structure.ByReference {
	}

	public WrapIDynamicKeyProviderConcept() {
	}

	public WrapIDynamicKeyProviderConcept(Pointer pvInstance) {
		super(pvInstance);
	}

	@Override
	public HRESULT GetKey(Pointer contextObject, WString key, PointerByReference keyValue,
			PointerByReference metadata, BOOLByReference hasKey) {
		return _invokeHR(VTIndices.GET_KEY, getPointer(), contextObject, key, keyValue, metadata,
			hasKey);
	}

	@Override
	public HRESULT SetKey(Pointer contextObject, WString key, Pointer keyValue, Pointer metadata) {
		return _invokeHR(VTIndices.SET_KEY, getPointer(), contextObject, key, keyValue, metadata);
	}

	@Override
	public HRESULT EnumerateKeys(Pointer contextObject, PointerByReference ppEnumerator) {
		return _invokeHR(VTIndices.ENUMERATE_KEYS, getPointer(), contextObject, ppEnumerator);
	}

}
