/* ###
 * IP: GHIDRA
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package sarif.export.data;

import ghidra.program.model.data.DataType;
import ghidra.program.model.data.TypeDef;
import ghidra.program.model.data.ISF.IsfTypedefPointer;

public class ExtIsfTypedefPointer extends IsfTypedefPointer {

	String typeName;
	String typeLocation;
	boolean autoNamed;
	String displayName;

	public ExtIsfTypedefPointer(TypeDef typedef) {
		super(typedef);
		if (typedef != null) {
			DataType base = typedef.getDataType();
			typeName = base.getName();
			typeLocation = base.getCategoryPath().getPath();
			autoNamed = typedef.isAutoNamed();
			displayName = typedef.getDisplayName();
		}
	}

}
