/* ###
 * IP: GHIDRA
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ghidra.app.util.bin.format.elf;

public class AVR8_ElfRelocationConstants {

	public static final int R_AVR_NONE = 0;
	public static final int R_AVR_32 = 1;
	public static final int R_AVR_7_PCREL = 2;
	public static final int R_AVR_13_PCREL = 3;
	public static final int R_AVR_16 = 4;
	public static final int R_AVR_16_PM = 5;
	public static final int R_AVR_LO8_LDI = 6;
	public static final int R_AVR_HI8_LDI = 7;
	public static final int R_AVR_HH8_LDI = 8;
	public static final int R_AVR_LO8_LDI_NEG = 9;
	public static final int R_AVR_HI8_LDI_NEG = 10;
	public static final int R_AVR_HH8_LDI_NEG = 11;
	public static final int R_AVR_LO8_LDI_PM = 12;
	public static final int R_AVR_HI8_LDI_PM = 13;
	public static final int R_AVR_HH8_LDI_PM = 14;
	public static final int R_AVR_LO8_LDI_PM_NEG = 15;
	public static final int R_AVR_HI8_LDI_PM_NEG = 16;
	public static final int R_AVR_HH8_LDI_PM_NEG = 17;
	public static final int R_AVR_CALL = 18;
	public static final int R_AVR_LDI = 19;
	public static final int R_AVR_6 = 20;
	public static final int R_AVR_6_ADIW = 21;
	public static final int R_AVR_MS8_LDI = 22;
	public static final int R_AVR_MS8_LDI_NEG = 23;
	public static final int R_AVR_LO8_LDI_GS = 24;
	public static final int R_AVR_HI8_LDI_GS = 25;
	public static final int R_AVR_8 = 26;
	public static final int R_AVR_8_LO8 = 27;
	public static final int R_AVR_8_HI8 = 28;
	public static final int R_AVR_8_HLO8 = 29;
	public static final int R_AVR_DIFF8 = 30;
	public static final int R_AVR_DIFF16 = 31;
	public static final int R_AVR_DIFF32 = 32;
	public static final int R_AVR_LDS_STS_16 = 33;
	public static final int R_AVR_PORT6 = 34;
	public static final int R_AVR_PORT5 = 35;

}
